"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HarmonyUiAppMain = void 0;
function _application() {
  const data = require("@teambit/application");
  _application = function () {
    return data;
  };
  return data;
}
function _cli() {
  const data = require("@teambit/cli");
  _cli = function () {
    return data;
  };
  return data;
}
function _ui() {
  const data = require("@teambit/ui");
  _ui = function () {
    return data;
  };
  return data;
}
function _component() {
  const data = require("@teambit/component");
  _component = function () {
    return data;
  };
  return data;
}
function _harmonyUiApp() {
  const data = require("./harmony-ui-app.aspect");
  _harmonyUiApp = function () {
    return data;
  };
  return data;
}
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
// import { HarmonyUIApp } from './ui.application';

class HarmonyUiAppMain {
  constructor(application, ui, componentAspect) {
    this.application = application;
    this.ui = ui;
    this.componentAspect = componentAspect;
  }

  /**
   * register a new harmony UI application.
   */
  registerHarmonyApp(options) {
    this.ui.registerUiRoot({
      name: options.name,
      path: this.componentAspect.getHost().path,
      configFile: '',
      async resolvePattern() {
        return [];
      },
      async resolveAspects() {
        return options.aspectDefs;
      }
    });

    // this.application.registerApp(new HarmonyUIApp(options.name, this.ui));

    return this;
  }
  static async provider([application, ui, componentAspect]) {
    return new HarmonyUiAppMain(application, ui, componentAspect);
  }
}
exports.HarmonyUiAppMain = HarmonyUiAppMain;
_defineProperty(HarmonyUiAppMain, "slots", []);
_defineProperty(HarmonyUiAppMain, "dependencies", [_application().ApplicationAspect, _ui().UIAspect, _component().ComponentAspect]);
_defineProperty(HarmonyUiAppMain, "runtime", _cli().MainRuntime);
_harmonyUiApp().HarmonyUiAppAspect.addRuntime(HarmonyUiAppMain);

//# sourceMappingURL=harmony-ui-app.main.runtime.js.map